=== debian/changelog ===
genwqe (4.0.12-0ubuntu3) xenial; urgency=high

  * Disable libcxl on ppc64el, not packaged.
  * Remove un-used header file.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 04 Mar 2016 11:38:17 +0000

genwqe (4.0.12-0ubuntu2) xenial; urgency=medium

  * Add missing build-dependency on zlib1g-dev.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 Feb 2016 13:01:59 +0000

genwqe (4.0.12-0ubuntu1) xenial; urgency=medium

  * Initial release LP: #1542371.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2016 13:20:45 +0000
