=== debian/control ===
Source: genwqe
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper (>=9), help2man, zlib1g-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/ibm-genwqe/genwqe-user/releases

Package: libzadc-dev
Section: libdevel
Architecture: any
Depends: libzadc1 (= ${binary:Version}), ${misc:Depends}
Description: accelerated libz implementation (development headers)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides headers and development libraries.

Package: libzadc1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: accelerated libz implementation (Accelerated Data Compression/ADC)
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides public libzADC library, and libz library
 symlinks which are not exposed in the ldconfig paths.

Package: genwqe
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for accelerated libz implementation
 Accelerated libz implementation uses FPGA based PCIe cards
 (e.g. zEDC) to accelerate compression/decompression.
 .
 This package provides utilities to use libzADC, as well as
 gzip/gunzip names for genwqe utilities in a subdirectory not in
 $PATH.
