=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

vars=VERSION=$(DEB_VERSION_UPSTREAM) CONFIG_ZLIB_PATH=/lib/$(DEB_HOST_MULTIARCH)/libz.so.1 V=2 libdir=/lib/$(DEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean -- $(vars)

override_dh_auto_build:
	dh_auto_build -- $(vars)

override_dh_auto_install:
	dh_auto_install -- $(vars)
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/
	ln -s /lib/$(DEB_HOST_MULTIARCH)/libzADC.so.1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libzADC.so
	ln -s /lib/$(DEB_HOST_MULTIARCH)/genwqe/libz.so.1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/genwqe/libz.so
	find debian/tmp -name '*.sh' -delete
	mkdir -p debian/tmp/usr/lib/
	mv debian/tmp/usr/bin/genwqe debian/tmp/usr/lib/ 

override_dh_auto_test:

override_dh_install:
	dh_install --list-missing
